summary: 	Small news server for small sites
Name: 		sn
Version: 	0.3.5
Release: 	3
Group: 		System Environment/Daemons
Copyright:      GPL
Packager:	Carles Arjona <nospammer@bigfoot.com>
URL:		http://www.iki.fi/patrik/sn/
BuildRoot:	/var/tmp/%{name}-%{version}-root
Source:		%{name}-%{version}.tar.gz
Source1:	sn.cron
Source2:	snntpd.sh
Source3:	sn.logrotate
Source4:	sn.init
BuildRequires:	zlib-devel

%description
sn is a small news system for small sites serving perhaps a few
dozen newsgroups, and with a slow connection to the internet.

%define spooldir /var/spool/%{name}
%define initrddir /etc/rc.d/init.d

%prep
%setup
mv Makefile Makefile.orig
grep -v ^SNROOT Makefile.orig|grep -v ^BINDIR|grep -v ^MANDIR | \
	sed s/'=newsmaster'/'=news'/ > Makefile

%build
SNROOT=%{spooldir}
BINDIR=%{_bindir}
MANDIR=%{_mandir}
export SNROOT BINDIR MANDIR
make

%install
[ "$RPM_BUILD_ROOT" != "" ] && rm -rf $RPM_BUILD_ROOT
SNROOT=$RPM_BUILD_ROOT%{spooldir}
BINDIR=$RPM_BUILD_ROOT%{_bindir}
MANDIR=$RPM_BUILD_ROOT%{_mandir}
mkdir -p $BINDIR
cp -p %SOURCE2 $RPM_BUILD_ROOT%{_bindir}
mkdir -p $MANDIR/man8
mkdir -p $RPM_BUILD_ROOT/%{_docdir}
mkdir -p $RPM_BUILD_ROOT/etc/cron.daily
cp -p %SOURCE1 $RPM_BUILD_ROOT/etc/cron.daily/sn
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
cp -p %SOURCE3 $RPM_BUILD_ROOT/etc/logrotate.d/sn
mkdir -p $RPM_BUILD_ROOT%{initrddir}
cp -p %SOURCE4 $RPM_BUILD_ROOT%{initrddir}/sn
install -o news -g news -d $SNROOT
mknod -m 600 $SNROOT/.fifo p
mkdir -p $RPM_BUILD_ROOT/var/log/sn

export SNROOT BINDIR MANDIR
make install

%post
# Update /etc/inetd.conf if exist
if [ -f /etc/inetd.conf ] && ! grep -q '^[# \t]*nntp' /etc/inetd.conf ; then
	echo >> /etc/inetd.conf
	echo "nntp stream tcp nowait news /usr/sbin/tcpd %{_bindir}/snntpd.sh" >> /etc/inetd.conf
        if [ -f /var/run/inetd.pid ] ; then
                kill -HUP `cat /var/run/inetd.pid`
        fi
fi
# xinetd configuration file
if [ -d /etc/xinetd.d ]; then
cat << END > /etc/xinetd.d/sn
# default: on
# description: News server for small sites.
service nntp
{
        disable = no
        socket_type             = stream
        protocol                = tcp
        wait                    = no
        user                    = news
        server                  = %{_bindir}/snntpd.sh
}
END
  if [ -f /var/run/xinetd.pid ] ; then
        /sbin/service xinetd reload > /dev/null 2>&1
  fi
fi
if ! grep -q '^[# \t]*snntpd' /etc/hosts.deny ; then
	echo >> /etc/hosts.deny
	echo "snntpd: ALL EXCEPT LOCAL" >> /etc/hosts.deny
fi
chkconfig sn on

%preun
chkconfig sn off

%postun
# The script gets 0 on uninstall, 1 on upgrade. Don't remove
# hosts.deny/inetd.conf lines on upgrade.
if [ "$1" = 0 ] ; then
	if [ -f /etc/inetd.conf ] &&
	   grep snntpd.sh /etc/inetd.conf > /dev/null 2>&1 ; then
		if grep -v snntpd.sh /etc/inetd.conf > /tmp/inetd.$$ ; then
			mv -f /tmp/inetd.$$ /etc/inetd.conf
        		if [ -f /var/run/inetd.pid ] ; then
                		kill -HUP `cat /var/run/inetd.pid`
        		fi
		fi
	elif [ -f /etc/xinetd.d/sn ]; then
	   rm -f /etc/xinetd.d/sn
	   if [ -f /var/run/xinetd.pid ] ; then
	        /sbin/service xinetd reload > /dev/null 2>&1
	   fi
	fi
	if [ -f /etc/hosts.deny ] &&
	   grep snntpd /etc/hosts.deny > /dev/null 2>&1 ; then
		if grep -v snntpd /etc/hosts.deny > /tmp/hosts.deny.$$ ; then
			mv -f /tmp/hosts.deny.$$ /etc/hosts.deny
		fi
	fi
fi
%clean
[ "$RPM_BUILD_ROOT" != "" ] && rm -rf $RPM_BUILD_ROOT

%files
/etc/cron.daily/sn
/etc/logrotate.d/sn
%attr(755,root,root)	%{initrddir}/sn
%doc CHANGES COPYING FAQ INSTALL* INTERNALS README* THANKS TODO
%attr(0644,root,root)	%{_mandir}/man?/*
%attr(2755,news,news)	%{_bindir}/*
%attr(2755,news,news)	%dir %{spooldir}
%attr(0600,news,news)	%{spooldir}/.fifo
%attr(2755,news,news)	%dir /var/log/sn

%changelog
* Sun Sep  1 2002 Carles Arjona <nospammer@bigfoot.com>
- fixed up spec file
- version 0.3.5-3 rpm

* Sun Sep  1 2002 Carles Arjona <nospammer@bigfoot.com>
- added /etc/logrotate.d/sn
- added both /etc/cron.daily/sn , snntpd.sh and init scripts
- added support for xinetd
- incorporated support for inetd from noffle.spec 1.0-1 by
  Jim Hague <jim.hague@acm.org>
- initial built for 0.3.5
